//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "fMain.h"
#include <algorithm>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
#define max(a, b)  (((a) > (b)) ? (a) : (b))
#define min(a, b)  (((a) < (b)) ? (a) : (b))
//---------------------------------------------------------------------------
double w=0.1;
double XX[1000],YY[1000];
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
   : TForm(Owner)
{
}
//---------------------------------------------------------------------------
bool __fastcall TForm1::MAXMIN(double* v, int len, double* M, double* N)
{
   *M=-MaxInt/1.0;
   *N=+MaxInt/1.0;
   for(int i=0;i<len;i++){
      *M=max(*M,v[i]);
      *N=min(*N,v[i]);
   }
   return M>N;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::scale(double left, double bottom, double right, double top)
{
   this->left=left;
   this->bottom=bottom;
   this->right=right;
   this->top=top;
}
//---------------------------------------------------------------------------
double __fastcall TForm1::RatioX()
{
   if(left==right)return 1;
   return (ClientWidth-2)/(right-left);
}
//---------------------------------------------------------------------------
double __fastcall TForm1::RatioY()
{
   if(top==bottom)return 1;
   return (ClientHeight-2)/(top-bottom);
}
//---------------------------------------------------------------------------
int __fastcall TForm1::f2pX(double x)
{
   int ret=(x-left)*RatioX()+1;
   return (int)ret;
}
//---------------------------------------------------------------------------
int __fastcall TForm1::f2pY(double y)
{
   float ret=(float)ClientHeight-(y-bottom)*RatioY()-2;
   return (int)ret;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::moveto(TCanvas *c, double x, double y)
{
   c->MoveTo(f2pX(x), f2pY(y));
}
//---------------------------------------------------------------------------
void __fastcall TForm1::lineto(TCanvas *c, double x, double y)
{
   c->LineTo(f2pX(x), f2pY(y));
}
//---------------------------------------------------------------------------
void __fastcall TForm1::line(TCanvas *c, double x0, double y0, double x1, double y1)
{
   c->MoveTo(f2pX(x0), f2pY(y0));
   c->LineTo(f2pX(x1), f2pY(y1));
}
//---------------------------------------------------------------------------
void __fastcall TForm1::InitialCanvas()
{
   Canvas->Pen->Width=1;
   Canvas->Pen->Color=clRed;
   Canvas->Pen->Style<<psSolid;
   Canvas->Pen->Mode=pmCopy;
   Canvas->Brush->Color=Color;
   Canvas->Brush->Style=bsSolid;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormResize(TObject *Sender)
{
   Repaint();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormPaint(TObject *Sender)
{
   if(calculated){
      InitialCanvas();
      line(Canvas,0,bottom,0,top);
      line(Canvas,left,0,right,0);
      Canvas->Pen->Width=2;
      Canvas->Pen->Color=clYellow;
      for(int i=0;i<1000;i++){
         if(i==0) moveto(Canvas,XX[i],YY[i]);
         else     lineto(Canvas,XX[i],YY[i]);
      }
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
   Color=clBlack;
   memset(&XX,0,sizeof(XX));
   memset(&YY,0,sizeof(YY));
   for(int i=0;i<1000;i++){
      int x=w*(i-500);
      XX[i]=x;
      YY[i]=f(x);
   }
   double M, N;
   if(MAXMIN(YY,1000,&M,&N)){
      scale(XX[0],N,XX[999],M);
   }
   calculated = true;
}
//---------------------------------------------------------------------------

